Imports Benday.Npr.Common.DomainModel
Imports Benday.Npr.Common.Repositories
Imports Benday.Npr.Common

Namespace Benday.Npr.Business
	Public Class StoryDomainService
		Implements IStoryDomainService

		Public Sub New(ByVal repository As IStoryRepository)
			If repository Is Nothing Then
				Throw New ArgumentNullException("repository", "repository is null.")
			End If

			m_RepositoryInstance = repository
		End Sub

		Private m_RepositoryInstance As IStoryRepository
		Private ReadOnly Property RepositoryInstance As IStoryRepository
			Get
				Return m_RepositoryInstance
			End Get
		End Property

        Public Sub GetStories(ByVal action As ReturnResult(Of IStoryList), ByVal id As String) Implements IStoryDomainService.GetStories

            RepositoryInstance.GetStories(action, id)
        End Sub

        Public Sub ResolveMp3UrlFromM3u(ByVal action As ReturnResult(Of String), ByVal m3uUri As String) Implements IStoryDomainService.ResolveMp3UrlFromM3u
            RepositoryInstance.ResolveMp3UrlFromM3u(action, m3uUri)
        End Sub
	End Class
End Namespace
