Imports Benday.Npr.Common.Repositories
Imports Benday.Npr.Common
Imports Benday.Npr.Common.DomainModel
Imports System.Net
Imports System.IO

Namespace Benday.Npr.DataAccess
	Public Class FeedRepository
		Implements IFeedRepository

		Public Sub New(ByVal factory As IObjectFactory)
			If factory Is Nothing Then
				Throw New ArgumentNullException("factory", "factory is null.")
			End If

			m_ObjectFactoryInstance = factory
		End Sub

		Private m_ObjectFactoryInstance As IObjectFactory
		Private ReadOnly Property ObjectFactoryInstance As IObjectFactory
			Get
				Return m_ObjectFactoryInstance
			End Get
		End Property

        Public Sub GetAllPrograms(ByVal action As ReturnResult(Of IFeed)) Implements IFeedRepository.GetAllPrograms
            If action Is Nothing Then
                Throw New ArgumentNullException("action", "action is null.")
            End If

            Dim xml As String = DataAccessResources.NprAllPrograms

            Dim adapter As IFeedXmlAdapter = ObjectFactoryInstance.Create(Of IFeedXmlAdapter)()

            Dim returnValue As IFeed = ObjectFactoryInstance.Create(Of IFeed)()

            adapter.Adapt(xml, returnValue)

            action.Notify(returnValue)
        End Sub


        'Public Sub GetAllPrograms(ByVal action As ReturnResult(Of IFeed))
        '          If action Is Nothing Then
        '              Throw New ArgumentNullException("action", "action is null.")
        '          End If

        '          Dim url As String = "http://api.npr.org/list?id=3004"

        '          Dim request As HttpWebRequest = TryCast(WebRequest.Create(url), HttpWebRequest)

        '          request.BeginGetResponse(AddressOf ProcessResult, New WebRequestReturnResult(Of IFeed)(request, action))
        '      End Sub

        '      Private Sub ProcessResult(ByVal asyncResult As IAsyncResult)
        '          Dim action As WebRequestReturnResult(Of IFeed) = TryCast(asyncResult.AsyncState, WebRequestReturnResult(Of IFeed))

        '          If action Is Nothing Then
        '              Throw New InvalidOperationException("User state was the wrong type.")
        '          End If

        '          Dim response = action.Request.EndGetResponse(asyncResult)

        '          Using stream = New StreamReader(response.GetResponseStream)
        '              Dim xml As String = stream.ReadToEnd

        '              Dim adapter As IFeedXmlAdapter = ObjectFactoryInstance.Create(Of IFeedXmlAdapter)()

        '              Dim returnValue As IFeed = ObjectFactoryInstance.Create(Of IFeed)()

        '              adapter.Adapt(xml, returnValue)

        '		System.Windows.Deployment.Current.Dispatcher.BeginInvoke(=> action.ReturnResult.Notify(returnValue))
        '          End Using
        '      End Sub
        '       * 
	End Class
End Namespace
