Imports Microsoft.VisualStudio.TestTools.UnitTesting
Imports Benday.Npr.Common

Namespace Benday.Npr.Silverlight.UnitTests
	<TestClass>
	Public Class ObjectIdentityFixture
		Inherits UnitTestBase

		<TestMethod>
		Public Sub ObjectIdentity_CreateInstance()
			Dim instance = ObjectFactoryInstance.Create(Of IObjectIdentity)()

			Assert.IsNotNull(instance, "Instance was null.")
		End Sub

		<TestMethod>
		Public Sub ObjectIdentity_ValueInitializedToUnsavedValue()
			Dim instance = ObjectFactoryInstance.Create(Of IObjectIdentity)()

			Assert.AreEqual(Of String)(instance.UnsavedValue, instance.Value, "Value should be unsaved value after ctor.")
		End Sub

		<TestMethod>
		Public Sub ObjectIdentity_IsSaved()
			Dim instance = ObjectFactoryInstance.Create(Of IObjectIdentity)()

			instance.Value = instance.UnsavedValue
			Assert.IsFalse(instance.IsSaved, "Should not be saved.")

			instance.Value = "asdf"
			Assert.IsTrue(instance.IsSaved, "Should be saved.")
		End Sub
	End Class
End Namespace
