Imports Microsoft.Silverlight.Testing
Imports Microsoft.VisualStudio.TestTools.UnitTesting
Imports Benday.Npr.Factories
Imports Benday.Npr.Common

Namespace Benday.Npr.Silverlight.UnitTests
	Public MustInherit Class UnitTestBase
		Inherits SilverlightTest

		Private m_additionalObjectFactoryConfiguration As ObjectFactoryConfiguration
		Public ReadOnly Property AdditionalObjectFactoryConfiguration As ObjectFactoryConfiguration
			Get
				If m_additionalObjectFactoryConfiguration Is Nothing Then
					m_additionalObjectFactoryConfiguration = New ObjectFactoryConfiguration

					PopulateAdditionalObjectFactoryConfiguration(m_additionalObjectFactoryConfiguration)
				End If

				Return m_additionalObjectFactoryConfiguration
			End Get
		End Property

		Protected Overridable Sub PopulateAdditionalObjectFactoryConfiguration(ByVal configuration As ObjectFactoryConfiguration)
		End Sub

		Private m_objectFactoryInstance As IObjectFactory
		Public ReadOnly Property ObjectFactoryInstance As IObjectFactory
			Get
				If m_objectFactoryInstance Is Nothing Then
					m_objectFactoryInstance = New ObjectFactory(AdditionalObjectFactoryConfiguration)
				End If

				Return m_objectFactoryInstance
			End Get
		End Property

		Public Sub ResetObjectFactoryInstance()
			m_objectFactoryInstance = Nothing
		End Sub

		Protected Overridable Sub OnTestInitialize()
			m_objectFactoryInstance = Nothing
			m_additionalObjectFactoryConfiguration = Nothing
		End Sub

		<TestInitialize>
		Public Sub TestInitialize()
			OnTestInitialize()
		End Sub

		Protected Overridable Sub OnClassInitialize()
		End Sub

		<ClassInitialize>
		Public Sub ClassInitialize()
			OnClassInitialize()
		End Sub
	End Class
End Namespace
