Imports System.Windows
Imports Microsoft.Phone.Controls

Namespace Benday.Npr.Phone
	Public NotInheritable Class ApplicationUtility
		Private Sub New()
		End Sub

		Public Shared Sub NavigateToMainPage()
			Dim root As PhoneApplicationFrame = TryCast(Application.Current.RootVisual, PhoneApplicationFrame)

			If root IsNot Nothing AndAlso DoesCurrentRootVisualSourceContain("MainPage.xaml") = False Then
				root.Navigate(New Uri("/MainPage.xaml", UriKind.Relative))
			End If
		End Sub

		Public Shared Function DoesCurrentRootVisualSourceContain(ByVal searchFor As String) As Boolean
			If String.IsNullOrEmpty(searchFor) = True Then
				Return False
			Else
				Dim root As PhoneApplicationFrame = TryCast(Application.Current.RootVisual, PhoneApplicationFrame)

				If root IsNot Nothing AndAlso root.CurrentSource IsNot Nothing Then
					Dim currentSourceAsString = root.CurrentSource.ToString

					If currentSourceAsString.Contains(searchFor) = True Then
						Return True
					Else
						Return False
					End If
				Else
					Return False
				End If
			End If
		End Function
	End Class
End Namespace
