Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Shapes
Imports Microsoft.Phone.Controls
Imports System.Windows.Navigation
Imports Benday.Npr.Presentation
Imports Microsoft.Xna.Framework.Media

Namespace Benday.Npr.Phone
	Partial Public Class HourlyNewsPage
		Inherits PhoneApplicationPage

		Public Sub New()
			InitializeComponent()
		End Sub

		Private m_ApplicationBarHelper As ApplicationBarBindingHelper
		Public ReadOnly Property ApplicationBarHelper As ApplicationBarBindingHelper
			Get
				Return m_ApplicationBarHelper
			End Get
		End Property

		Private m_ViewModel As Benday.Npr.Presentation.Interfaces.IStoryListViewModel

		Private Sub PhoneApplicationPage_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
			m_ViewModel = ViewModelLocator.Instance.StoryListInstance

			Me.DataContext = m_ViewModel
		End Sub

		Protected Overrides Sub OnNavigatedTo(ByVal e As NavigationEventArgs)
            ' CheckApplicationBarHelper()

			If ViewModelLocator.IsInDesignModeStatic = False AndAlso ViewModelLocator.Instance.CurrentProgram IsNot Nothing Then
				m_ViewModel = ViewModelLocator.Instance.StoryListInstance

				Me.DataContext = m_ViewModel

				If ViewModelLocator.Instance.CurrentProgram IsNot Nothing AndAlso ViewModelLocator.Instance.CurrentProgram.Id <> m_ViewModel.Id Then
					m_ViewModel.Load(ViewModelLocator.Instance.CurrentProgram.Id)
				End If

                ' CheckApplicationBarHelper()
			End If
		End Sub

		Private Sub CheckApplicationBarHelper()
			If m_ApplicationBarHelper Is Nothing Then
				m_ApplicationBarHelper = New ApplicationBarBindingHelper(ApplicationBar, ViewModelLocator.Instance.AllPrograms.MediaPlayback)
			End If
		End Sub

		Private Sub PlayTrack()
			Try
				If m_ViewModel IsNot Nothing AndAlso m_ViewModel.Stories IsNot Nothing AndAlso m_ViewModel.Stories.Count > 0 AndAlso m_ViewModel.Stories(0) IsNot Nothing Then
					Dim uri As New Uri(m_ViewModel.Stories(0).ResolvedUrlToMp3, UriKind.RelativeOrAbsolute)

					Dim song As Song = Song.FromUri(Guid.NewGuid.ToString, uri)

					Microsoft.Xna.Framework.Media.MediaPlayer.Play(song)

                    'Dim launcher = New MediaPlayerLauncher

                    'launcher.Media = New Uri(ViewModelLocator.Instance.CurrentStory.ResolvedUrlToMp3, UriKind.RelativeOrAbsolute)
                    'launcher.Location = MediaLocationType.Data
                    'launcher.Show
				End If
			Catch ex As Exception
				MessageBox.Show(ex.Message)
			End Try
		End Sub

		Private Sub CheckPlaybackStateAndOptionallyPlayTrack()
			If MediaPlayer.GameHasControl = False AndAlso MediaPlayer.State = MediaState.Playing Then
				Dim result = MessageBox.Show("Would you like to stop the current music playback?", "Stop current track?", MessageBoxButton.OKCancel)

                If result = MessageBoxResult.OK Then
                    PlayTrack()
                End If
			Else
				PlayTrack()
			End If
		End Sub

		Private Sub viewModel_OnReadyToPlayMp3(ByVal sender As Object, ByVal e As EventArgs)
			CheckPlaybackStateAndOptionallyPlayTrack()
		End Sub

		Private Sub Button_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			Try
				If m_ViewModel IsNot Nothing AndAlso m_ViewModel.Stories IsNot Nothing AndAlso m_ViewModel.Stories.Count > 0 AndAlso m_ViewModel.Stories(0) IsNot Nothing Then
					Dim storyViewModelInstance = m_ViewModel.Stories(0)

					' if subscribed to the event, unsubscribe...this ensures that we don't get two events
					RemoveHandler storyViewModelInstance.OnReadyToPlayMp3, AddressOf viewModel_OnReadyToPlayMp3

					' subscribe to the event
					AddHandler storyViewModelInstance.OnReadyToPlayMp3, AddressOf viewModel_OnReadyToPlayMp3

					storyViewModelInstance.PlayMp3()
				End If
			Catch ex As Exception
				MessageBox.Show(ex.ToString)
			End Try
		End Sub
	End Class
End Namespace
