Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Shapes
Imports Microsoft.Phone.Controls
Imports System.Windows.Navigation
Imports Benday.Npr.Presentation
Imports Microsoft.Phone.Tasks
Imports Microsoft.Xna.Framework.Media
Imports Microsoft.Phone.BackgroundAudio

Namespace Benday.Npr.Phone
	Partial Public Class StoryDetailsPage
		Inherits PhoneApplicationPage

		Public Sub New()
			InitializeComponent()
		End Sub

		Private m_ApplicationBarHelper As ApplicationBarBindingHelper
		Public ReadOnly Property ApplicationBarHelper As ApplicationBarBindingHelper
			Get
				Return m_ApplicationBarHelper
			End Get
		End Property

		Private Sub PhoneApplicationPage_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
		End Sub

		Public Sub CheckDataContextAndEventSubscriptions()
			If ViewModelLocator.Instance.CurrentStory IsNot Nothing Then
				Dim viewModel = ViewModelLocator.Instance.CurrentStory

				Me.DataContext = viewModel

				AddHandler viewModel.OnReadyToPlayMp3, AddressOf viewModel_OnReadyToPlayMp3
			End If
		End Sub

		Protected Overrides Sub OnNavigatedTo(ByVal e As NavigationEventArgs)
			CheckDataContextAndEventSubscriptions()
		End Sub

		Private Sub CheckApplicationBarHelper()
			If m_ApplicationBarHelper Is Nothing Then
				m_ApplicationBarHelper = New ApplicationBarBindingHelper(Me.ApplicationBar, ViewModelLocator.Instance.AllPrograms.MediaPlayback)
			End If
		End Sub

		Private Sub PlayTrack()
			Try
				Dim storyViewModel = ViewModelLocator.Instance.CurrentStory
				Dim programViewModel = ViewModelLocator.Instance.CurrentProgram
				Dim uri As New Uri(storyViewModel.ResolvedUrlToMp3, UriKind.RelativeOrAbsolute)

				Dim track As New AudioTrack(uri, storyViewModel.Title, programViewModel.Title, storyViewModel.PublishDate.ToShortDateString, Nothing)

				BackgroundAudioPlayer.Instance.Track = track
				BackgroundAudioPlayer.Instance.Play()
			Catch ex As Exception
				MessageBox.Show(ex.Message)
			End Try
		End Sub

'        
        'Private Sub PlayTrack()
        '          Try
        '              Dim uri As New Uri(ViewModelLocator.Instance.CurrentStory.ResolvedUrlToMp3, UriKind.RelativeOrAbsolute)

        '              Dim song As Song = Song.FromUri(Guid.NewGuid.ToString, uri)

        '              Microsoft.Xna.Framework.Media.MediaPlayer.Play(song)
        '          Catch ex As Exception
        '              MessageBox.Show(ex.Message)
        '          End Try
        '      End Sub
        '        
		Private Sub CheckPlaybackStateAndOptionallyPlayTrack()
			If MediaPlayer.GameHasControl = False AndAlso MediaPlayer.State = MediaState.Playing Then
				Dim result = MessageBox.Show("Would you like to stop the current music playback?", "Stop current track?", MessageBoxButton.OKCancel)

                If result = MessageBoxResult.OK Then
                    PlayTrack()
                End If
			Else
				PlayTrack()
			End If
		End Sub

		Private Sub viewModel_OnReadyToPlayMp3(ByVal sender As Object, ByVal e As EventArgs)
			CheckPlaybackStateAndOptionallyPlayTrack()
		End Sub

		Private Sub Button_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			Try
				ViewModelLocator.Instance.CurrentStory.PlayMp3()
			Catch ex As Exception
				MessageBox.Show(ex.ToString)
			End Try
		End Sub
	End Class
End Namespace
