Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Shapes
Imports System.Windows.Navigation
Imports Microsoft.Phone.Controls
Imports Benday.Npr.Presentation
Imports Benday.Npr.Presentation.Interfaces

Namespace Benday.Npr.Phone
	Partial Public Class StoryListPage
		Inherits PhoneApplicationPage

		' Constructor
		Public Sub New()
			InitializeComponent()
		End Sub

		Private m_ApplicationBarHelper As ApplicationBarBindingHelper
		Public ReadOnly Property ApplicationBarHelper As ApplicationBarBindingHelper
			Get
				Return m_ApplicationBarHelper
			End Get
		End Property

		Private Sub PhoneApplicationPage_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
			m_ViewModel = ViewModelLocator.Instance.StoryListInstance

			Me.DataContext = m_ViewModel
		End Sub

		' When page is navigated to set data context to selected item in list
		Protected Overrides Sub OnNavigatedTo(ByVal e As NavigationEventArgs)
			If ViewModelLocator.IsInDesignModeStatic = False AndAlso ViewModelLocator.Instance.CurrentProgram IsNot Nothing Then
				m_ViewModel = ViewModelLocator.Instance.StoryListInstance

				Me.DataContext = m_ViewModel

				If ViewModelLocator.Instance.CurrentProgram IsNot Nothing AndAlso ViewModelLocator.Instance.CurrentProgram.Id <> m_ViewModel.Id Then
					m_ViewModel.Load(ViewModelLocator.Instance.CurrentProgram.Id)
				End If

				AddHandler m_ViewModel.OnSelectionChanged, AddressOf viewModel_OnSelectionChanged

                ' CheckApplicationBarHelper()
			End If
		End Sub

		Private Sub CheckApplicationBarHelper()
			If m_ApplicationBarHelper Is Nothing Then
				m_ApplicationBarHelper = New ApplicationBarBindingHelper(Me.ApplicationBar, ViewModelLocator.Instance.AllPrograms.MediaPlayback)
			End If
		End Sub

		Private m_ViewModel As Benday.Npr.Presentation.Interfaces.IStoryListViewModel

		Private Sub NavigateToStory()
			If m_ViewModel IsNot Nothing AndAlso m_ViewModel.SelectedItem IsNot Nothing Then
				NavigationService.Navigate(New Uri("/StoryDetailsPage.xaml", UriKind.Relative))
			End If
		End Sub

		Private Sub viewModel_OnSelectionChanged(ByVal sender As Object, ByVal e As EventArgs)
			NavigateToStory()
		End Sub

		Private Sub StackPanel_MouseLeftButtonDown(ByVal sender As Object, ByVal e As MouseButtonEventArgs)
		End Sub

		Private Sub StackPanel_MouseLeftButtonUp(ByVal sender As Object, ByVal e As MouseButtonEventArgs)
			NavigateToStory()
		End Sub
	End Class
End Namespace
