Imports Microsoft.Phone.Shell

Namespace Benday.Npr.Phone
	Public MustInherit Class ViewModelSerializerBase
		Public Const SERIALIZATION_KEY_STORY As String = "Story"
		Public Const SERIALIZATION_KEY_PROGRAM As String = "Program"
		Public Const SERIALIZATION_KEY_STORY_LIST As String = "StoryList"
		Public Const SERIALIZATION_KEY_RESUME_ACTION As String = "ResumeAction"
		Public Const SERIALIZATION_KEY_RESUME_ACTION_STORY As String = "STORY"
		Public Const SERIALIZATION_KEY_RESUME_ACTION_PROGRAM As String = "PROGRAM"
		Public Const SERIALIZATION_KEY_RESUME_ACTION_HOURLY_NEWS As String = "HOURLY NEWS"

		Public Sub New()
		End Sub

		Private Shared Sub RemoveStateValue(ByVal key As String)
			Dim stateCollection As IDictionary(Of String, Object) = PhoneApplicationService.Current.State

			If stateCollection.ContainsKey(key) = True Then
				stateCollection.Remove(key)
			End If
		End Sub

		Protected Shared Function GetStateValue(ByVal key As String) As String
			Dim stateCollection As IDictionary(Of String, Object) = PhoneApplicationService.Current.State

			Return TryCast(stateCollection(key), String)
		End Function

		Protected Shared Sub SetStateValue(ByVal key As String, ByVal value As String)
			RemoveStateValue(key)

			Dim stateCollection As IDictionary(Of String, Object) = PhoneApplicationService.Current.State

			stateCollection.Add(key, value)
		End Sub

		Protected Shared Function HasStateValue(ByVal key As String) As Boolean
			Dim stateCollection As IDictionary(Of String, Object) = PhoneApplicationService.Current.State

			Return stateCollection.ContainsKey(key)
		End Function

		Public Shared Sub ClearState()
			RemoveStateValue(SERIALIZATION_KEY_RESUME_ACTION)
			RemoveStateValue(SERIALIZATION_KEY_PROGRAM)
			RemoveStateValue(SERIALIZATION_KEY_STORY_LIST)
			RemoveStateValue(SERIALIZATION_KEY_STORY)
		End Sub

		Public Shared Sub SetResumeActionToProgram()
			SetStateValue(SERIALIZATION_KEY_RESUME_ACTION, SERIALIZATION_KEY_RESUME_ACTION_PROGRAM)
		End Sub

		Public Shared Sub SetResumeActionToHourlyNews()
			SetStateValue(SERIALIZATION_KEY_RESUME_ACTION, SERIALIZATION_KEY_RESUME_ACTION_HOURLY_NEWS)
		End Sub

		Public Shared Sub SetResumeActionToStory()
			SetStateValue(SERIALIZATION_KEY_RESUME_ACTION, SERIALIZATION_KEY_RESUME_ACTION_STORY)
		End Sub
	End Class
End Namespace
