Imports GalaSoft.MvvmLight
Imports System.Windows.Input
Imports Benday.Npr.Presentation.Interfaces

Namespace Benday.Npr.Presentation
	Public MustInherit Class EditorViewModel
		Inherits IdentityViewModel
		Implements IEditorViewModel

		Public Sub New()
		End Sub
        Public Overloads Property Id As Common.IObjectIdentity Implements IEditorViewModel.Id
        Private Const IsNetworkAvailablePropertyName As String = "IsNetworkAvailable"
        Private m_IsNetworkAvailable As Boolean
        Public Overloads Property IsNetworkAvailable As Boolean Implements IEditorViewModel.IsNetworkAvailable
            Get
                Return m_IsNetworkAvailable
            End Get
            Set(ByVal value As Boolean)
                m_IsNetworkAvailable = value
                RaisePropertyChanged(IsNetworkAvailablePropertyName)
            End Set
        End Property
		Public MustOverride Sub Save() Implements IEditorViewModel.Save

		Public MustOverride Sub Cancel() Implements IEditorViewModel.Cancel

		Private m_cancelCommand As ICommand
		Public Property CancelCommand As ICommand Implements IEditorViewModel.CancelCommand
			Get
				If m_cancelCommand Is Nothing Then
					m_cancelCommand = New GalaSoft.MvvmLight.Command.RelayCommand(Sub() Me.Cancel)
				End If

				Return m_cancelCommand
			End Get
			Set(ByVal value As ICommand)
				m_cancelCommand = value
			End Set
		End Property

		Private m_saveCommand As ICommand
		Public Property SaveCommand As ICommand Implements IEditorViewModel.SaveCommand
			Get
				If m_saveCommand Is Nothing Then
					m_saveCommand = New GalaSoft.MvvmLight.Command.RelayCommand(Sub() Me.Save)
				End If

				Return m_saveCommand
			End Get
			Set(ByVal value As ICommand)
				m_saveCommand = value
			End Set
		End Property
	End Class
End Namespace
