Imports GalaSoft.MvvmLight
Imports System.Windows.Input
Imports System.Collections.ObjectModel
Imports Benday.Npr.Common

Namespace Benday.Npr.Presentation
	Public MustInherit Class ObjectFactoryViewModel
		Inherits NetworkAvailabilityViewModel

		Public Sub New(ByVal factory As IObjectFactory)
			If factory Is Nothing Then
				Throw New ArgumentNullException("factory", "factory is null.")
			End If

			m_ObjectFactoryInstance = factory
		End Sub

		Private m_ObjectFactoryInstance As IObjectFactory
		Protected ReadOnly Property ObjectFactoryInstance As IObjectFactory
			Get
				Return m_ObjectFactoryInstance
			End Get
		End Property
	End Class
End Namespace
