Imports GalaSoft.MvvmLight
Imports System.Windows.Input
Imports System.Collections.ObjectModel
Imports Benday.Npr.Common
Imports Benday.Npr.Presentation.Interfaces
Imports Benday.Npr.Common.DomainModel

Namespace Benday.Npr.Presentation
	Public Class ProgramViewModel
		Inherits NetworkAvailabilityViewModel
		Implements IProgramViewModel
        Public Overloads Property IsNetworkAvailable As Boolean Implements IProgramViewModel.IsNetworkAvailable
		Public Sub New()
		End Sub

		Private Const IdPropertyName As String = "Id"

		Private m_Id As String
		Public Property Id As String Implements IProgramViewModel.Id
			Get
				Return m_Id
			End Get
			Set(ByVal value As String)
				m_Id = value
				RaisePropertyChanged(IdPropertyName)
			End Set
		End Property

		Private Const TitlePropertyName As String = "Title"

		Private m_Title As String
		Public Property Title As String Implements IProgramViewModel.Title
			Get
				Return m_Title
			End Get
			Set(ByVal value As String)
				m_Title = value
				RaisePropertyChanged(TitlePropertyName)
			End Set
		End Property

		Private Const AdditionalInformationPropertyName As String = "AdditionalInformation"

		Private m_AdditionalInformation As String
		Public Property AdditionalInformation As String Implements IProgramViewModel.AdditionalInformation
			Get
				Return m_AdditionalInformation
			End Get
			Set(ByVal value As String)
				m_AdditionalInformation = value
				RaisePropertyChanged(AdditionalInformationPropertyName)
			End Set
		End Property
	End Class
End Namespace
