Namespace Benday.Npr.Phone.Common
	Public Class ReturnResult(Of T)
		''' <summary>
		''' No callback required
		''' </summary>
		Public Sub New()
			m_callback = Nothing
		End Sub

		Public Sub New(ByVal callback As Action(Of ReturnResult(Of T)))
			If callback Is Nothing Then
				Throw New ArgumentNullException("callback", "callback is null.")
			End If

			m_callback = callback
		End Sub

		Public Sub New(ByVal callback As Action(Of ReturnResult(Of T)), ByVal parentCall As ReturnResult(Of T))
			If callback Is Nothing Then
				Throw New ArgumentNullException("callback", "callback is null.")
			End If
			If parentCall Is Nothing Then
				Throw New ArgumentNullException("parentCall", "parentCall is null.")
			End If

			m_callback = callback
			Me.ParentCall = parentCall
		End Sub

		Private m_callback As Action(Of ReturnResult(Of T))

        Private _parentCall As ReturnResult(Of T)
		Public Property ParentCall As ReturnResult(Of T)
			Get
                Return _parentCall
			End Get
			Private Set(ByVal value As ReturnResult(Of T))
                _parentCall = value
			End Set
		End Property

        Private _error As Exception
        Public Property [Error] As Exception
            Get
                Return _error
            End Get
            Private Set(ByVal value As Exception)
                _error = value
            End Set
        End Property

        Private _result As T
		Public Property Result As T
			Get
                Return _result
			End Get
			Private Set(ByVal value As T)
                _result = value
			End Set
		End Property

		Public Sub Notify(ByVal ex As Exception)
			[Error] = ex
			If m_callback IsNot Nothing Then
				m_callback(Me)
			End If
		End Sub

		Public Sub Notify(ByVal result As T)
			Me.Result = result
			If m_callback IsNot Nothing Then
				m_callback(Me)
			End If
		End Sub

		Public Sub NotifyParentCall()
			If ParentCall IsNot Nothing Then
				If [Error] IsNot Nothing Then
					ParentCall.Notify([Error])
				Else
					ParentCall.Notify(Result)
				End If
			End If
		End Sub
	End Class
End Namespace
