Imports Benday.Npr.Phone.Common
Imports System.Net

Namespace Benday.Npr.Phone.DataAccess
	Public Class WebRequestReturnResult(Of T)
		Public Sub New(ByVal request As HttpWebRequest, ByVal action As ReturnResult(Of T))
			If request Is Nothing Then
				Throw New ArgumentNullException("request", "request is null.")
			End If
			If action Is Nothing Then
				Throw New ArgumentNullException("action", "action is null.")
			End If

			m_Request = request
			m_ReturnResult = action
		End Sub

		Private m_Request As HttpWebRequest
		Public ReadOnly Property Request As HttpWebRequest
			Get
				Return m_Request
			End Get
		End Property

		Private m_ReturnResult As ReturnResult(Of T)
		Public ReadOnly Property ReturnResult As ReturnResult(Of T)
			Get
				Return m_ReturnResult
			End Get
		End Property
	End Class
End Namespace
