Imports System.Collections.ObjectModel
Imports System.Windows.Input

Namespace Benday.Npr.Phone.Presentation
	Public Class MessageBoxEventArgs
		Inherits EventArgs

		Public Sub New(ByVal message As String)
			If String.IsNullOrEmpty(message) Then
				Throw New ArgumentException("message is null or empty.", "message")
			End If

			Me.Message = message
			IsUnexpectedException = False
			Exception = Nothing
		End Sub

		''' <summary>
		''' Initializes a new instance of the MessageBoxEventArgs class.
		''' </summary>
		Public Sub New(ByVal message As String, ByVal isUnexpectedException As Boolean, ByVal exception As Exception)
			If String.IsNullOrEmpty(message) Then
				Throw New ArgumentException("message is null or empty.", "message")
			End If
			If exception Is Nothing Then
				Throw New ArgumentNullException("exception", "exception is null.")
			End If

			Me.Message = message
			Me.IsUnexpectedException = isUnexpectedException
			Me.Exception = exception
		End Sub

		''' <summary>
		''' Initializes a new instance of the MessageBoxEventArgs class.
		''' </summary>
		Public Sub New(ByVal message As String, ByVal exception As Exception)
			Me.New(message, True, exception)
		End Sub

        Private _message As String
		Public Property Message As String
			Get
                Return _message
			End Get
			Private Set(ByVal value As String)
                _message = value
			End Set
		End Property

        Private _isUnexpectedException As Boolean
		Public Property IsUnexpectedException As Boolean
			Get
                Return _isUnexpectedException
			End Get
			Private Set(ByVal value As Boolean)
                _isUnexpectedException = value
			End Set
		End Property

        Private _exception As Exception
		Public Property Exception As Exception
			Get
                Return _exception
			End Get
			Private Set(ByVal value As Exception)
                _exception = value
			End Set
		End Property
	End Class
End Namespace
