Imports Benday.Npr.Phone.Presentation.Interfaces

Namespace Benday.Npr.Phone.Presentation
	Public MustInherit Class MessageBoxViewModelBase
		Inherits GalaSoft.MvvmLight.ViewModelBase
		Implements IViewModelBase

		Public Event MessageBoxRequested As MessageBoxEventHandler Implements IViewModelBase.MessageBoxRequested

		Public Overridable Sub RequestMessageBox(ByVal message As String)
            If MessageBoxRequestedEvent IsNot Nothing Then
                RaiseEvent MessageBoxRequested(Me, New MessageBoxEventArgs(message))
            End If
		End Sub

		Public Overridable Sub RequestMessageBox(ByVal message As String, ByVal isUnexpectedException As Boolean, ByVal ex As Exception)
            If MessageBoxRequestedEvent IsNot Nothing Then
                RaiseEvent MessageBoxRequested(Me, New MessageBoxEventArgs(message, isUnexpectedException, ex))
            End If
		End Sub

		Protected Overridable Sub RequestMessageBox(ByVal message As String, ByVal ex As Exception)
            If MessageBoxRequestedEvent IsNot Nothing Then
                RaiseEvent MessageBoxRequested(Me, New MessageBoxEventArgs(message, ex))
            End If
		End Sub
	End Class
End Namespace
