Imports GalaSoft.MvvmLight
Imports System.Collections.ObjectModel
Imports Benday.Npr.Phone.Presentation.Interfaces
Imports Benday.Npr.Phone.Common

Namespace Benday.Npr.Phone.Presentation
	Public Class SelectableItem
		Inherits ViewModelBase
		Implements ISelectableItem

		Public Sub New()
		End Sub

		''' <summary>
		''' Initializes a new instance of the SelectableItem class.
		''' </summary>
		''' <param name="isSelected"></param>
		''' <param name="text"></param>
		Public Sub New(ByVal isSelected As Boolean, ByVal text As String)
			Me.New(isSelected, text, text)
		End Sub

		''' <summary>
		''' Initializes a new instance of the SelectableItemViewModel class.
		''' </summary>
		''' <param name="isSelected"></param>
		''' <param name="text"></param>
		''' <param name="value"></param>
		Public Sub New(ByVal isSelected As Boolean, ByVal text As String, ByVal value As String)
			m_IsSelected = isSelected
			m_Text = text
			m_Value = value
		End Sub

		Public Sub New(ByVal isSelected As Boolean, ByVal id As String, ByVal text As String, ByVal value As String, ByVal description As String)
			m_Id = id
			m_IsSelected = isSelected
			m_Text = text
			m_Value = value
			m_Description = description
		End Sub

		Private Const IsSelectedPropertyName As String = "IsSelected"

		Private m_IsSelected As Boolean
		Public Property IsSelected As Boolean Implements Benday.Npr.Phone.Presentation.Interfaces.ISelectable.IsSelected
			Get
				Return m_IsSelected
			End Get
			Set(ByVal value As Boolean)
				If m_IsSelected <> value Then
					m_IsSelected = value
					RaisePropertyChanged(IsSelectedPropertyName)
				End If
			End Set
		End Property

		Private Const TextPropertyName As String = "Text"

		Private m_Text As String
		Public Property Text As String Implements ISelectableItem.Text
			Get
				Return m_Text
			End Get
			Set(ByVal value As String)
				m_Text = value
				RaisePropertyChanged(TextPropertyName)
			End Set
		End Property

		Private Const ValuePropertyName As String = "Value"

		Private m_Value As String
		Public Property Value As String Implements ISelectableItem.Value
			Get
				Return m_Value
			End Get
			Set(ByVal value As String)
				m_Value = value
				RaisePropertyChanged(ValuePropertyName)
			End Set
		End Property

		Public Overrides Function ToString() As String
			Return Text
		End Function

		Private Const DescriptionPropertyName As String = "Description"

		Private m_Description As String
		Public Property Description As String Implements ISelectableItem.Description
			Get
				Return m_Description
			End Get
			Set(ByVal value As String)
				m_Description = value
				RaisePropertyChanged(DescriptionPropertyName)
			End Set
		End Property

		Private Const IdPropertyName As String = "Id"

		Private m_Id As String
		Public Property Id As String Implements ISelectableItem.Id
			Get
				Return m_Id
			End Get
			Set(ByVal value As String)
				m_Id = value
				RaisePropertyChanged(IdPropertyName)
			End Set
		End Property
	End Class
End Namespace
