Imports Microsoft.VisualStudio.TestTools.UnitTesting
Imports Benday.Npr.Phone.DataAccess
Imports Benday.Npr.Phone.Common.Repositories

Namespace Benday.Npr.Phone.UnitTests.DataAccess
	Public Class StoryRepositoryTester
		''' <summary>
		''' Initializes a new instance of the StoryRepositoryTester class.
		''' </summary>
		''' <param name="repositoryInstance"></param>
		Public Sub New(ByVal repositoryInstance As StoryRepository)
			m_RepositoryInstance = repositoryInstance

			AddHandler m_RepositoryInstance.StoryListRefreshed, AddressOf m_RepositoryInstance_StoryListRefreshed
		End Sub

		Private Sub m_RepositoryInstance_StoryListRefreshed(ByVal sender As Object, ByVal e As StoryListRefreshedEventArgs)
			m_WasStoryListRefreshedEventReceived = True
			m_ProgramId = e.ProgramId
		End Sub

		Private m_ProgramId As String
		Public ReadOnly Property ProgramId As String
			Get
				Return m_ProgramId
			End Get
		End Property

		Private m_WasStoryListRefreshedEventReceived As Boolean
		Public ReadOnly Property WasStoryListRefreshedEventReceived As Boolean
			Get
				Return m_WasStoryListRefreshedEventReceived
			End Get
		End Property

		Private m_RepositoryInstance As StoryRepository
		Public ReadOnly Property RepositoryInstance As StoryRepository
			Get
				Return m_RepositoryInstance
			End Get
		End Property

		Public Sub AssertEvent(ByVal programId As String)
			Assert.IsTrue(m_WasStoryListRefreshedEventReceived, "Didn't get StoryListRefreshed event.")
			Assert.AreEqual(Of String)(programId, m_ProgramId, "The received program id was wrong.")
		End Sub
	End Class
End Namespace
