Imports Microsoft.VisualStudio.TestTools.UnitTesting
Imports Microsoft.Silverlight.Testing

Namespace Benday.Npr.Phone.UnitTests.DataAccess
	<TestClass, Tag("UndisplayableHtml")>
	Public Class UnitTestUtilityFixture
		Public Sub New()
		End Sub

		<TestMethod>
		Public Sub StringContainsUndisplayableHtmlFormatting_NoUndisplayableHtml()
			Dim checkThisString As String = "This is some text without undisplayable html."

			Assert.IsFalse(UnitTestUtility.StringContainsUndisplayableHtmlFormatting(checkThisString))
		End Sub

		<TestMethod>
		Public Sub StringContainsUndisplayableHtmlFormatting_EscapedEmphasisTag_WithContent()
			Dim checkThisString As String = "This is some text &lt;em&gt;asdf&lt;/em&gt; more text."

			Assert.IsTrue(UnitTestUtility.StringContainsUndisplayableHtmlFormatting(checkThisString))
		End Sub

		<TestMethod>
		Public Sub StringContainsUndisplayableHtmlFormatting_EscapedEmphasisTag_WithoutContent()
			Dim checkThisString As String = "This is some text &lt;em&gt;&lt;/em&gt; more text."

			Assert.IsTrue(UnitTestUtility.StringContainsUndisplayableHtmlFormatting(checkThisString))
		End Sub

		<TestMethod>
		Public Sub StringContainsUndisplayableHtmlFormatting_UnescapedEmphasisTag_WithContent()
			Dim checkThisString As String = "This is some text <em>asdf</em> more text."

			Assert.IsTrue(UnitTestUtility.StringContainsUndisplayableHtmlFormatting(checkThisString))
		End Sub

		<TestMethod>
		Public Sub StringContainsUndisplayableHtmlFormatting_UnescapedEmphasisTag_WithoutContent()
			Dim checkThisString As String = "This is some text <em></em> more text."

			Assert.IsTrue(UnitTestUtility.StringContainsUndisplayableHtmlFormatting(checkThisString))
		End Sub

		<TestMethod>
		Public Sub StringContainsUndisplayableHtmlFormatting_UnescapedStrongTag_WithContent()
			Dim checkThisString As String = "This is some text <strong>asdf</strong> more text."

			Assert.IsTrue(UnitTestUtility.StringContainsUndisplayableHtmlFormatting(checkThisString))
		End Sub

		<TestMethod>
		Public Sub StringContainsUndisplayableHtmlFormatting_UnescapedStrongTag_WithoutContent()
			Dim checkThisString As String = "This is some text <strong></strong> more text."

			Assert.IsTrue(UnitTestUtility.StringContainsUndisplayableHtmlFormatting(checkThisString))
		End Sub
	End Class
End Namespace
