Imports Microsoft.VisualStudio.TestTools.UnitTesting
Imports Microsoft.Silverlight.Testing
Imports Benday.Npr.Phone.Common

Namespace Benday.Npr.Phone.UnitTests.DataAccess
	<TestClass, Tag("xml")>
	Public Class XmlUtilityFixture
		Inherits UnitTestBase

		<TestMethod>
		Public Sub XmlUtility_GetChildElementValueByElementNameAndAttributeId()
			Dim xml As String = TestDataUtility.XmlWithSimilarChildElementsWithDifferentAttributes

			' <link type="html">http://www.npr.org/2010/11/10/131216486/in-israel-when-is-a-jew-not-jewish-enough?ft=3&amp;f=2</link>

			Dim expected As String = "http://www.npr.org/2010/11/10/131216486/in-israel-when-is-a-jew-not-jewish-enough?ft=3&f=2"

			Dim root = XmlUtility.StringToXDocument(xml)

			Dim actual = XmlUtility.GetChildElementValue(root.Root, "link", "type", "html", String.Empty)

			Assert.AreEqual(Of String)(expected, actual, "Value was wrong.")
		End Sub

		<TestMethod>
		Public Sub GetAttributeValueAsInt32_ReturnsIntForValidValue()
			Dim expected = 1234

			Dim element As New XElement("element")
			Dim attribute As New XAttribute("attr", expected.ToString)
			element.Add(attribute)

			Dim actual = XmlUtility.GetAttributeValueAsInt32(element, "attr", -1)

			Assert.AreEqual(Of Integer)(expected, actual, "Got the wrong value.")
		End Sub

		<TestMethod>
		Public Sub GetAttributeValueAsInt32_ReturnsIntForInvalidValue()
			Dim expected = -1

			Dim element As New XElement("element")
			Dim attribute As New XAttribute("attr", "this is not an int32")
			element.Add(attribute)

			Dim actual = XmlUtility.GetAttributeValueAsInt32(element, "attr", expected)

			Assert.AreEqual(Of Integer)(expected, actual, "Got the wrong value.")
		End Sub
	End Class
End Namespace
