Imports System.Windows
Imports Microsoft.Phone.Shell

Namespace Benday.Npr.Phone
	Public Class NavigateToHomeApplicationBarWatcher
		Public Sub New(ByVal home As ApplicationBarIconButton)
			If home Is Nothing Then
				Throw New ArgumentNullException("home", "home is null.")
			End If

			m_Home = home

			UpdateButtons()
		End Sub

		Private m_Home As ApplicationBarIconButton
		Public ReadOnly Property Home As ApplicationBarIconButton
			Get
				Return m_Home
			End Get
		End Property

		Private Sub UpdateButtons()
			If IsLightThemeEnabled() = True Then
				Home.IconUri = New Uri("/Images/Icons/Light/appbar.home.rest.png", UriKind.Relative)
			Else
				Home.IconUri = New Uri("/Images/Icons/Dark/appbar.home.rest.png", UriKind.Relative)
			End If
		End Sub

		Public Function IsLightThemeEnabled() As Boolean
			Dim lightTheme As Visibility = CType(Application.Current.Resources("PhoneLightThemeVisibility"), Visibility)

            If lightTheme = System.Windows.Visibility.Visible Then
                Return True
            Else
                Return False
            End If
		End Function
	End Class
End Namespace
