Imports System.Windows
Imports Microsoft.Phone.Shell

Namespace Benday.Npr.Phone
	Public Class RefreshStoriesApplicationBarWatcher
		Public Sub New(ByVal refresh As ApplicationBarIconButton)
			If refresh Is Nothing Then
				Throw New ArgumentNullException("refresh", "refresh is null.")
			End If

			m_Refresh = refresh

			UpdateButtons()
		End Sub

		Private m_Refresh As ApplicationBarIconButton
		Public ReadOnly Property Refresh As ApplicationBarIconButton
			Get
				Return m_Refresh
			End Get
		End Property

		Private Sub UpdateButtons()
			If IsLightThemeEnabled() = True Then
				Refresh.IconUri = New Uri("/Images/Icons/Light/appbar.refresh.rest.png", UriKind.Relative)
			Else
				Refresh.IconUri = New Uri("/Images/Icons/Dark/appbar.refresh.rest.png", UriKind.Relative)
			End If
		End Sub

		Public Function IsLightThemeEnabled() As Boolean
			Dim lightTheme As Visibility = CType(Application.Current.Resources("PhoneLightThemeVisibility"), Visibility)

            If lightTheme = System.Windows.Visibility.Visible Then
                Return True
            Else
                Return False
            End If
		End Function
	End Class
End Namespace
