Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Shapes
Imports Microsoft.Phone.Controls
Imports Benday.Npr.Phone.Presentation.Interfaces
Imports Benday.Npr.Phone.Presentation
Imports Microsoft.Phone.BackgroundAudio
Imports Microsoft.Xna.Framework.Media
Imports System.Threading

Namespace Benday.Npr.Phone
	Partial Public Class StoryDetailsPage
		Inherits PhoneApplicationPage

		Public Sub New()
			InitializeComponent()
		End Sub

		Private m_ViewModel As IStoryViewModel

		Private Sub PhoneApplicationPage_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
			m_ViewModel = ViewModelLocator.Instance.Story

			AddHandler m_ViewModel.OnReadyToPlayMp3, AddressOf m_ViewModel_OnReadyToPlayMp3

			Me.DataContext = m_ViewModel

			m_ViewModel.Load()

			m_Watcher = New NavigateToHomeApplicationBarWatcher(TryCast(ApplicationBar.Buttons(0), Microsoft.Phone.Shell.ApplicationBarIconButton))
		End Sub

		Private m_Watcher As NavigateToHomeApplicationBarWatcher

		Private Sub m_HomeButton_Click(ByVal sender As Object, ByVal e As EventArgs)
			NavigationService.Navigate(New Uri("/MainPage.xaml", UriKind.Relative))
		End Sub

		Private Sub m_ViewModel_OnReadyToPlayMp3(ByVal sender As Object, ByVal e As EventArgs)
			Try
				PlayTrack(m_ViewModel)
			Catch ex As Exception
				MessageBox.Show(ex.ToString)
			End Try
		End Sub

		Private Sub PlayTrack(ByVal viewModel As IStoryViewModel)
			Dim uri As New Uri(viewModel.ResolvedUrlToMp3, UriKind.RelativeOrAbsolute)

			Dim track As New AudioTrack(uri, viewModel.Title, viewModel.ShowName, viewModel.PublishDate.ToShortDateString, Nothing, viewModel.AudioTrackLocatorTag, EnabledPlayerControls.All)

			BackgroundAudioPlayer.Instance.Track = track
			BackgroundAudioPlayer.Instance.Play()
		End Sub

		Private Sub PlayTrack()
			PlayTrack(m_ViewModel)
		End Sub

		Private Sub CheckPlaybackStateAndOptionallyPlayTrack()
			If MediaPlayer.GameHasControl = False AndAlso MediaPlayer.State = MediaState.Playing Then
				Dim result = MessageBox.Show("Would you like to stop the current music playback?", "Stop current track?", MessageBoxButton.OKCancel)

                If result = MessageBoxResult.OK Then
                    m_ViewModel.PlayMp3()
                End If
			Else
				m_ViewModel.PlayMp3()
			End If
		End Sub

		Private Sub m_BtnPlay_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			Try
				If m_ViewModel Is Nothing Then
					Exit Sub
				Else
					CheckPlaybackStateAndOptionallyPlayTrack()
				End If
			Catch ex As Exception
				MessageBox.Show(ex.ToString)
			End Try
		End Sub
	End Class
End Namespace
